∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘

> {-# LANGUAGE UnicodeSyntax #-}
> {-# OPTIONS_GHC -Wall -Wcompat -Wnoncanonical-monad-instances -Wnoncanonical-monadfail-instances
>                 -fno-warn-name-shadowing -fno-warn-missing-signatures -fno-warn-missing-methods
>                 -fno-warn-redundant-constraints -fno-warn-type-defaults -fno-warn-unused-imports #-}
>
> import Control.Exception (Exception, catch, throw)
> import Data.List (sort)

∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘∘


Классы типов
=============

> data CompilationResult = CompilationOk | CompilationFailed Integer String

> -- class Show a where
> --   showsPrec :: Int -> a -> ShowS
> --   show :: a -> String
> --   showList :: [a] -> ShowS
>
> --   showsPrec _ a s = show a ++ s
> --   show a = showsPrec 0 a ""
> --   showList xs = {- тоже как-то реализовано по-умолчанию -}

Помните, что в классах типов у некоторых (обычно, многих) методов
есть реализации по-умолчанию через другие методы. Например, в `Show`
метод `show` реализован через `showsPrec`, а `showsPrec` — через `show`,
так что достаточно реализовать любой один из них. А если не реализовать ни один,
то, как легко видеть, получится бесконечная рекурсия. Не надо так.

◊1.1 Реализуйте класс `Show` для типа `CompilationResult`:

> instance Show CompilationResult where
>   -- show :: CompilationResult -> String
>   show = (??)

> tests_1_1 = [ show CompilationOk == "Ok"
>             , show (CompilationFailed 12 "oops") == "Failed at line 12: oops"
>             ]


> -- class Eq a where
> --   (==) :: a -> a -> Bool
> --   (/=) :: a -> a -> Bool
>
> --   x == y = not (x /= y)
> --   x /= y = not (x == y)

◊1.2 Реализуйте класс `Eq` для типа `CompilationResult`:

> instance Eq CompilationResult where
>   -- (==) :: CompiltationResult -> CompilationResult -> Bool
>   (==) = (??)

> tests_1_2 = [ CompilationOk == CompilationOk
>             , CompilationOk /= CompilationFailed 15 "wow"
>             , CompilationFailed 15 "wow" /= CompilationOk
>             , CompilationFailed 128 "wow" == CompilationFailed 128 "wow"
>             , CompilationFailed 10 "oops" /= CompilationFailed 128 "wow"
>             ]


> data Tree a = Leaf | Fork (Tree a) a (Tree a)
>
> treeHi :: Tree String
> treeHi = Fork Leaf "hi" Leaf
>
> tree123 :: Tree Integer
> tree123 = Fork (Fork Leaf 1 Leaf) 2 (Fork Leaf 3 Leaf)
>
> vine :: Integral n => n -> Tree n
> vine 0 = Leaf
> vine n = Fork (vine $ n - 1) n Leaf
>
> rightInf :: Tree ()
> rightInf = Fork Leaf () rightInf


◊2.1★ Реализуйте класс `Show` для типа `Tree a` (не стесняйтесь дописать что-нибудь в шаблон):

> instance Show (Tree a) where
>   show = (??)
>   showsPrec _ = (??)

> tests_2_1 = [ show (Leaf :: Tree Char) == "()"
>             , show treeHi == "{() \"hi\" ()}"
>             , show tree123 == "{{() 1 ()} 2 {() 3 ()}}"
>             , length (show (vine $ 2^16)) == 709792
>             ]

◊2.2★★  Реализуйте класс `Eq` для типа `Tree a` (не стесняйтесь дописать что-нибудь в шаблон):

> instance Eq (Tree a) where
>   (==) = (??)
>   (/=) = (??)

> tests_2_2 = [ (Leaf :: Tree ()) == Leaf
>             , (Leaf :: Tree String) /= treeHi
>             , treeHi == treeHi
>             , treeHi /= (Fork Leaf "foo" Leaf)
>             , tree123 == tree123
>             , tree123 /= (Fork Leaf 2 (Fork Leaf 3 Leaf))
>             ]


◊3.1★★ Посмотрите в документации, что за класс такой `Ord`, и реализуйте его для
       типа `CompilationResult` так, чтобы успех был меньше всех, а провалы сравнивались
       по кодам ошибки (постарайтесь написать как можно меньше строк кода):

> instance Ord CompilationResult where
>   compare = (??)

> tests_3_1 = [ CompilationOk < CompilationFailed 500 "oops"
>             , CompilationOk < CompilationFailed (-500) "oops"
>             , not (CompilationFailed 400 "wow" > CompilationFailed 400 "wow")
>             , CompilationFailed 400 "zab" >= CompilationFailed 400 "baz"
>             , CompilationFailed (-500) "ugh" < CompilationFailed 1 "huh"
>             ]


◊3.2★★ С помощью документации изучите классы `Bounded` и `Enum`. Определим класс `SafeEnum`,
       в котором есть методы `ssucc` и `spred`, работающие как `succ` и `pred`,
       но не кидающие ошибку при попытке выйти за границы диапазона, а переходящие, так сказать,
       по циклу. Задайте дефолтные реализации этих функций, чтобы можно было объявлять инстансы
       `SafeEnum` (не для всех, конечно, типов, но для многих), ничего не реализуя
       (не стесняйтесь дописать что-нибудь в шаблон).

> class {- … -} SafeEnum a where
>   ssucc :: a -> a
>   ssucc = (??)
>   spred :: a -> a
>   spred = (??)
>
> instance SafeEnum Bool where
>   -- сюда ничего писать нельзя
> instance SafeEnum Ordering where
>   -- сюда ничего писать нельзя
> instance SafeEnum Int where
>   -- сюда ничего писать нельзя

> tests_3_2 = [ ssucc True == False
>             , ssucc False == True
>             , spred False == True
>             , spred True == False
>             , ssucc LT == EQ
>             , ssucc EQ == GT
>             , ssucc GT == LT
>             , spred GT == EQ
>             , spred EQ == LT
>             , spred LT == GT
>             , ssucc (53 :: Int) == 54
>             , spred (87 :: Int) == 86
>             ]


Определим тип нечетных целых чисел следующим образом:

> data Odd = Odd Integer
>   deriving (Eq, Show)

Мы сейчас всё пишем в одном файле, но если бы разрабатывали реальное приложение,
у нас было бы несколько модулей, и с помощью модульной системы мы могли бы сделать
этот конструктор недоступным, чтобы не допустить создания некорректных значений.
Вместо этого мы бы экспортировали функцию, проверяющую свой вход прежде, чем создать
новый элемент типа `Odd` (эта техника называется smart constructors):

> mkOdd :: Integer -> Odd
> mkOdd n | odd n     = Odd n
>         | otherwise = error "mkOdd: Not odd"

В общем, считайте, что извне пользоваться конструктором `Odd` напрямую нельзя, и потому
некорректных значений этого типа не бывает.

◊3.3★ Сделайте тип `Odd` инстансом класса `Enum`. Он должен вести себя так же,
      как стандатные инстансы, например, `Integer`. Методы `toEnum` и `fromEnum`
      можете не реализовывать, поскольку их поведение всё равно нигде не специфицировано.

> instance Enum Odd where
>   succ = (??)
>   pred = (??)
>   enumFrom = (??)
>   enumFromThen = (??)
>   enumFromTo = (??)
>   enumFromThenTo = (??)

> tests_3_3 = [ succ (mkOdd 5) == mkOdd 7
>             , pred (mkOdd 1) == mkOdd (-1)
>             , [mkOdd 1 .. mkOdd 7] == [mkOdd 1, mkOdd 3, mkOdd 5, mkOdd 7]
>             ]



◊4.1 Вставьте элемент на указанную позицию в списке. Если список слишком короткий,
     просто добавляйте в конец.

> insertAt :: Integral n => n -> a -> [a] -> [a]
> insertAt = (??)

> tests_4_1 = [ insertAt 2 'w' "ohow" == "ohwow"
>             , insertAt 500 True [] == [True]
>             ]

◊4.2★ Реализуйте функцию, удаляющую элемент с указанной позиции в списке.

> removeAt :: Integral n => n -> [a] -> (Maybe a, [a])
> removeAt = (??)

> tests_4_2 = [ removeAt 2 "ohwow" == (Just 'w', "ohow")
>             , removeAt 500 [True] == (Nothing, [True])
>             ]

◊4.3★★ Зациклите список.

> cycleList :: [a] -> [a]
> cycleList = (??)

> tests_4_3 = [ take 7 (cycleList [1,2,3]) == [1,2,3,1,2,3,1]
>             ]

◊4.4★ Реализуйте `enumerate` из Питона.

> enumerate :: Integral n => n -> [a] -> [(n, a)]
> enumerate = (??)

> tests_4_4 = [ enumerate 2 "hello" == [(2, 'h'), (3, 'e'), (4, 'l'), (5, 'l'), (6, 'o')]
>             ]


◊5.1★ Реализуйте [эффективную] функцию, которая получает на вход два остортированных
      списка и возвращает отсортированный список, содержащий все элементы исходных.

> unionList :: Ord a => [a] -> [a] -> [a]
> unionList = (??)

> tests_5_1 = [ unionList [1, 2, 3] [4, 5, 6] == [1, 2, 3, 4, 5, 6]
>             , unionList [4, 5, 6] [1, 2, 3] == [1, 2, 3, 4, 5, 6]
>             , unionList [3, 5, 6] [1, 3, 5, 8] == [1, 3, 3, 5, 5, 6, 8]
>             ]


◊5.2★★ Реализуйте функцию, отражающую дерево относительно вертикальной оси.

> mirrorTree :: Tree a -> Tree a
> mirrorTree = (??)

> tests_5_2 = [ case mirrorTree tree123 of
>                 Fork (Fork Leaf 3 Leaf) 2 (Fork Leaf 1 Leaf) -> True
>                 _ -> False
>             , case mirrorTree treeHi of
>                 Fork Leaf "hi" Leaf -> True
>                 _ -> False
>             ]


◊5.3★★★ Реализуйте функцию, генерирующую список чисел от одного до n в виде строк,
        причем, если число делится на 3, то вместо него должна быть строка "Fizz",
        если делится на 5 — строка "Buzz", а если и на 3, и на 5, то "FizzBuzz".

> fizzbuzz :: (Integral n, Show n) => n -> [String]
> fizzbuzz n = (??)

> tests_5_3 = [ fizzbuzz 6 == ["1", "2", "Fizz", "4", "Buzz", "Fizz"]
>             ]


◊5.4★★ Реализуйте функцию, выдающую элементы дерева в виде списка в естественном порядке.

> treeList :: Tree a -> [a]
> treeList = (??)

> tests_5_4 = [ treeList tree123 == [1, 2, 3]
>             , length (treeList (vine $ 2^16)) == 2^16
>             ]

◊5.5★★★ Реализуйте функцию, выдающую элементы дерева в виде списка в естественном порядке,
        работающую, в том числе, с бесконечными деревьями.

> treeListInf :: Tree a -> [a]
> treeListInf = (??)

> tests_5_5 = [ treeListInf tree123 == [1, 2, 3]
>             , length (treeListInf (vine $ 2^16)) == 2^16
>             , take 5 (treeListInf rightInf) == [(), (), (), (), ()]
>             ]



List comprehension
-------------------

В Хаскеле есть специальный синтаксис для работы со списками, который
сочетает в себе функции `map`, `fiter` и чего-то вроде `zipWith`.

> list1 = [1 .. 6]
> list2 = [ x * 2 | x <- list1 ]  -- [2, 4, 6, 8, 10, 12]
> list3 = [ x * 2 | x <- list1, even x ]  -- [4, 8, 12]

> list4 = [ (i, j) | i <- [1..3], j <- [1..2] ]  -- [(1,1), (1,2), (2,1), (2,2), (3,1), (3,2)]
> list5 = [ (i, j) | i <- [1..3], odd i, j <- [1..2] ]  -- [(1,1), (1,2), (3,1), (3,2)]
> list6 = [  i + j | i <- [1..3], odd i, j <- [1..2] ]  -- [    2,     3,     4,     5]
> list7 = [ (i, j) | i <- [1..3], odd i, j <- [i..3] ]  -- [(1,1),(1,2),(1,3),(3,3)]


◊6.1★ Запишите list comprehension, значением которого являются все пифагоровы тройки
      из натуральных чисел, не превышающих n.

> pythTriples :: Integral n => n -> [(n, n, n)]
> pythTriples n = [ (??) ]

> tests_6_1 = [ sort (pythTriples 15) == [(3,4,5), (5,12,13), (6,8,10), (9,12,15)]
>             , length (pythTriples 100) == 52
>             ]



Класс `Read`
-------------

Класс `Read` устроен как-то странно, и реализовывать его не надо (надо писать
нормальные парсеры, но об этом позже). Но есл в образовательных целях, то можно.
Есть полезная функция `reads`, которая определена не в самом этом классе, но с
его использованием (в самом классе есть `readsPrec`).

> read1 = reads "5" :: [(Int, String)]  -- [(5, "")]
> read2 = reads "21hello" :: [(Int, String)]  -- [(21, "hello")]
> read3 = reads "hello" :: [(Int, String)]  -- []

Как нетрудно видеть, она возвращает пару из распаршенного значения и оставшейся
части строки. Точнее, возвращает она не просто пару, а список таких пар —
по задумке авторов, на тот случай, если есть несколько корректных авторов разбора,
но этим никто не пользуется. Зато тот факт что, если строка совсем не разбирается,
то возвращается пустой список, весьма удобен.

Если мы будем писать наш «парсер» с помощью list comprehensions, будут происходить
всякие полезные спецэффекты — например, если где-то что-то не разобралось и
вернулся пустой список, у нас тоже автоматически вернется пустой список.
Также мы можем паттерн-матчиться на значениях, поскольку list comprehension
специально устроены так, чтобы это можно было делать (как с булевыми условиями):

> list8 = [Just 1, Nothing, Just 2, Just 3, Nothing]
> list9 = [ x | Just x <- list8 ]  -- [1, 2, 3]

В качестве примера, прочитаем тройки целых чисел, разделенных решеткой ("12#0#156").

> -- type ReadS a = String -> [(a, String)]

> myTripleReads :: (Read n, Integral n) => ReadS (n, n, n)
> myTripleReads s = [ ((a, b, c), s3) | (a, '#':s1) <- reads s
>                                     , (b, '#':s2) <- reads s1
>                                     , (c, s3) <- reads s2
>                   ]

> tripleReads1 = myTripleReads "12#0#156"  -- [((12,0,156),"")]
> tripleReads2 = myTripleReads "1234#10!fdsklj"  -- []
> tripleReads3 = myTripleReads "1234#10#20fdsklj"  -- [((1234,10,20),"fdsklj")]


◊6.2★★★ Реализуйте `reads` для деревьев. Читать надо тот формат, который выдает
        инстанс Show.

> myTreeReads :: Read a => ReadS (Tree a)
> myTreeReads = (??)

> instance Read a => Read (Tree a) where
>   readsPrec _ = myTreeReads

> tests_6_2 = [ case read "()" :: Tree Char of
>                 Leaf -> True
>                 _ -> False
>             , case read "{() \"hi\" ()}" :: Tree String of
>                 Fork Leaf "hi" Leaf -> True
>                 _ -> False
>             , case read "{{() 1 ()} 2 {() 3 ()}}" :: Tree Int of
>                 Fork (Fork Leaf 1 Leaf) 2 (Fork Leaf 3 Leaf) -> True
>                 _ -> False

>             , case reads "blablabla" :: [(Tree Int, String)] of
>                 [] -> True
>                 _ -> False
>             , case reads "{{()1 ()} 2 {() 3 ()}}" :: [(Tree Int, String)] of
>                 [] -> True
>                 _ -> False
>             , case reads "{{() 1 () 2 {() 3 ()}}" :: [(Tree Int, String)] of
>                 [] -> True
>                 _ -> False
>             , case reads "{{() 1 ()}  {() 3 ()}}" :: [(Tree Int, String)] of
>                 [] -> True
>                 _ -> False
>             , case reads "{{() 1 ()}2{() 3 ()}}" :: [(Tree Int, String)] of
>                 [] -> True
>                 _ -> False
>             ]



----------------------------------- ~fin~ -----------------------------------



Дальше нет ничего интересного.


\begin{code}

  data Skipped = Skipped
  instance Exception Skipped where
  instance Show Skipped where
    show Skipped = "skipped"

  (??){- Вместо этих вопросиков ничего писать не надо, их, очевидно, надо оставить на месте -} = throw Skipped

  ok_if_defined x = seq x True

  main :: IO ()
  main = sequence_ $ map (uncurry runTests) tests
    where
      tests = [ ("1.1", tests_1_1), ("1.2", tests_1_2)
              , ("2.1", tests_2_1), ("2.2", tests_2_2)
              , ("3.1", tests_3_1), ("3.2", tests_3_2), ("3.3", tests_3_3)
              , ("4.1", tests_4_1), ("4.2", tests_4_2), ("4.3", tests_4_3), ("4.4", tests_4_4)
              , ("5.1", tests_5_1), ("5.2", tests_5_2), ("5.3", tests_5_3), ("5.4", tests_5_4), ("5.5", tests_5_5)
              , ("6.1", tests_6_1), ("6.2", tests_6_2)
              ]

      runTests :: String -> [Bool] -> IO ()
      runTests n ts = do
        putStr $ "Running tests " ++ show n ++ "... "
        catch (putStr $ if (and ts) then "OK" else "FAIL") (\e -> putStr . show $ (e :: Skipped))
        putStrLn ""

\end{code}
